// ObjectViewerView.cpp : implementation of the CObjectViewerView class
//
/*

  Title:	ObjectViewer
  Author:	Claudio Eduardo Storti Lago
  email:	webmaster@computersorcerer.com
  http://www.computersorcerer.com

  ps:	this source can be distributed freely, but you need to
		mention the author's name.

*/

#include "stdafx.h"
#include "ObjectViewer.h"

#include "ObjectViewerDoc.h"
#include "ObjectViewerView.h"
#include "TransDlg.h"
#include "ScaleDlg.h"
#include "RotateDlg.h"
#include "MirrorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CObjectViewerView

IMPLEMENT_DYNCREATE(CObjectViewerView, CView)

BEGIN_MESSAGE_MAP(CObjectViewerView, CView)
	//{{AFX_MSG_MAP(CObjectViewerView)
	ON_COMMAND(ID_TRANSFORM_MIRROR, OnTransformMirror)
	ON_COMMAND(ID_TRANSFORM_ROTATE, OnTransformRotate)
	ON_COMMAND(ID_TRANSFORM_SCALE, OnTransformScale)
	ON_COMMAND(ID_TRANSFORM_TRANSLATE, OnTransformTranslate)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CObjectViewerView construction/destruction

CObjectViewerView::CObjectViewerView()
{
	// TODO: add construction code here
}

CObjectViewerView::~CObjectViewerView()
{
}

BOOL CObjectViewerView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CObjectViewerView drawing

void CObjectViewerView::OnDraw(CDC* pDC)
{
	CObjectViewerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CRect windowRect;


	// TODO: add draw code for native data here
	GetWindowRect(&windowRect);
	pDoc->Object2d.DrawObject(pDC,windowRect);
}

/////////////////////////////////////////////////////////////////////////////
// CObjectViewerView diagnostics

#ifdef _DEBUG
void CObjectViewerView::AssertValid() const
{
	CView::AssertValid();
}

void CObjectViewerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CObjectViewerDoc* CObjectViewerView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CObjectViewerDoc)));
	return (CObjectViewerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CObjectViewerView message handlers

void CObjectViewerView::OnTransformMirror() 
{
	// TODO: Add your command handler code here
	CObjectViewerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);	
	
	CMirrorDlg dlg;

	if (dlg.DoModal()==IDOK) {
		if (dlg.m_xMirror)
			pDoc->Object2d.Mirror(XONLY);
		if (dlg.m_yMirror)
			pDoc->Object2d.Mirror(YONLY);
		Invalidate();
	}
}

void CObjectViewerView::OnTransformRotate() 
{
	// TODO: Add your command handler code here
	CObjectViewerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);	
	
	CRotateDlg dlg;
	
	if (dlg.DoModal()){
		pDoc->Object2d.Rotate(dlg.m_degAngle,dlg.m_xO,dlg.m_yO);
		Invalidate();	
	}
}

void CObjectViewerView::OnTransformScale() 
{
	// TODO: Add your command handler code here
	CObjectViewerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);	
	
	CScaleDlg dlg;

	if (dlg.DoModal()==IDOK) {
		pDoc->Object2d.Scale(dlg.m_xScale,dlg.m_yScale);
		Invalidate();		
	}
}

void CObjectViewerView::OnTransformTranslate() 
{
	// TODO: Add your command handler code here
	CObjectViewerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);	
	
	CTransDlg dlg;
	if (dlg.DoModal()==IDOK) {
		pDoc->Object2d.Translate(dlg.m_xInc,dlg.m_yInc);
		Invalidate();		
	}
}

void CObjectViewerView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
}
